module Heft
  module Internal
    class HoistConnection
      def initialize(opts={})
        @internet = opts[:internet] || fail("You need to supply :internet")
        @api_key  = opts[:api_key]  || fail("You need to supply :api_key")
      end
      
      [:get, :post, :delete].each do |m|
        define_method m do |opts|
          execute m, opts
        end
      end

      private

      def execute(verb, opts={})
        @internet.execute T::Request.new(
          :headers  => headers,
          :uri      => opts[:uri],
          :verb     => verb,
          :body     => opts[:body]
        ) 
      end

      def headers
        {
          'Authorization' => "HOIST #{@api_key}",
          'Content-Type'  => 'application/json',
          'Accept'        => 'application/json'
        }
      end
    end
  end
end
