module Heft
  class Users
    require File.join '.', 'adapters', 'internet'
    
    class << self 
      def add(opts={})
        reply = add_core opts

        fail "Failed => #{reply.body}" if reply.code > 299
      end

      def delete(email)
        reply = hoist.delete :uri => "https://auth.hoi.io/user/#{URI.escape(email)}"

        fail "Failed to delete user. #{reply}" if reply.code > 299
      end

      def contain?(email)
        reply = add_core :email => email, :password => "******"

        json = JSON.parse reply.body

        error_message = json['message']

        reply.code === 400 and error_message.match /already a user with that email address/
      end

      private
      
      def hoist
        Heft::Internal::HoistConnection.new :internet => internet, :api_key => ENV['APIKEY'] 
      end

      def internet; Adapters::Internet.new; end

      def add_core(opts={})
        hoist.post(
          :uri  => 'https://auth.hoi.io/user',
          :body => opts
        )
      end
    end
  end
end
